//windlog
//
//

int windPin = 0;
int ondoSensorPin = 1;
int cdsPin = 2;

double temperatureVal;

unsigned long int sumOndoVal,sumCdsVal,sumWindVal;
unsigned long int loopCnt;
unsigned long int lastMillis;
unsigned long int interval = 600000;//10分に一回(600000ミリ秒)プロセッシングに送信


void setup() {
  Serial.begin(9600);
	pinMode(13,OUTPUT);
}


void loop() {
	//温度センサの値を取得
  int ondoSensorVal = analogRead(ondoSensorPin);
	//温度センサの値を摂氏にする
  int temperature = map(ondoSensorVal,0,205,0,100);
  sumOndoVal +=temperature;

	//CdS(明るさ)センサの値を取得
  int cdsVal = analogRead(cdsPin);//明るいと1023,暗いとそれ以外
  sumCdsVal += cdsVal;

	//風力キットの値を取得
  float windVal = analogRead(windPin);
  sumWindVal += windVal;

	//平均値をとるためのカウンター
  loopCnt++;

	//インターバルをこえるとPCに送信
  if(millis()-lastMillis>interval){
			//ループ数で割った平均値
      int aveTemperature = sumOndoVal/loopCnt;
      int aveCdsVal = sumCdsVal/loopCnt;
      int aveWindVal = sumWindVal/loopCnt;

      Serial.print(aveTemperature,DEC);//温度センサの平均値を送信
      Serial.print(",");
      Serial.print(aveCdsVal,DEC);//cdsの平均値を送信
      Serial.print(",");
      Serial.println(aveWindVal,DEC);//風力センサの平均値を送信
      //Serial.read();

      sumOndoVal=0;
      sumCdsVal=0;
      sumWindVal=0;
      loopCnt = 0;

			digitalWrite(13,HIGH);
			delay(300);
			digitalWrite(13,LOW);

      lastMillis = millis();
  }
}


