//windlog processing
//
//

String twitterID = "*****"; //投稿用のtwitterIDを設定してください
String twitterPassword = "*****"; //投稿用のtwitterPasswordを設定してください
String AREAID = "63";//現在天気予報が東京に設定されています。以下のアドレスから設置した地点のエリアIDを探してください
//http://weather.livedoor.com/forecast/rss/forecastmap.xml


import processing.serial.*;
import processing.xml.*;
Serial myPort;
Twitter twitter; 
//rss read from livedoor®forecast service
//http://weather.livedoor.com/weather_hacks/rss_feed_list.html
String FeedURL = "http://weather.livedoor.com/forecast/webservice/rest/v1?city="+AREAID+"&day=today";


//読み込み値の変数を用意
int tempVal,cdsVal,windVal;
static boolean serialCame=false;
boolean night = false;//夜か昼か
final int cdsThreashold = 500;//cdsセンサの閾値
final int windThreashold = 1000;//風力ロガーの閾値
final int errorCelsius = -274;//エラー時の設定

//初期化
void setup(){
  twitter = new Twitter(twitterID,twitterPassword);
  println(Serial.list());
  String portName = Serial.list()[0];
  myPort = new Serial(this,portName, 9600);
  myPort.clear();
  myPort.bufferUntil(10);

  forecastMaxC = getForecastMaxCelsius(FeedURL);
  forecastMinC = getForecastMinCelsius(FeedURL);
  dateGotHour=hour();
}


int lastSerialVal;
int dateGotHour;
int forecastMaxC;
int forecastMinC;
String stringData;

void draw(){

  //もしSerialEventフラグがたっていたら
  if(serialCame==true){
    if(stringData!=null){
      int data[]=int(split(stringData,','));

      if(data.length==3){
        tempVal=data[0];
        cdsVal=data[1];
        windVal=data[2];
      }
    }

    if(night==true&&cdsVal<cdsThreashold){
      twit("明るくなってきた…");
      night = false;
    }
    else if(night==false&&cdsVal>cdsThreashold){
      twit("暗くなってきたね");
      night = true;
    }
    else if(windVal>windThreashold){
      twit("強い風が吹いた");
    }
    else if(windVal>windThreashold*1.5){
      twit("結構強い風が吹いた");
    }
    else if(forecastMaxC!=errorCelsius&&forecastMaxC<tempVal){
      twit("今日の岐阜の予想最高気温は"+forecastMaxC+"度,だけどIAMASは"+tempVal+"度");
    }
    else if(forecastMinC!=errorCelsius&&forecastMinC>tempVal){
      twit("今日の岐阜の予想最低気温は"+forecastMaxC+"度,だけどIAMASは"+tempVal+"度");	
    }
    else{
      twit(tempVal+"度、明るさ"+cdsVal+"、風力"+windVal);  
    }

    //監視用フラグをもとに戻す
    serialCame=false;
  }


  //１時間ごとに天気予報apiを見に行く
  //最後に取得した日付から変わっていたら取得しにいく
  if(dateGotHour!=hour()){
    //予想最高気温をゲット
    forecastMaxC = getForecastMaxCelsius(FeedURL);
    forecastMinC = getForecastMinCelsius(FeedURL);
    dateGotHour=hour();	
  }
}







void serialEvent(Serial p){
  stringData=myPort.readStringUntil(10);
  stringData=trim(stringData);
  println("serial受信"+stringData);

  //監視用フラグをたてる
  serialCame = true;
}

//インターネットから予想最高気温を取得する
int getForecastMaxCelsius(String feedUrl){
  int gotCelsiusNumb = -274;

  try{
    XMLElement xml = new XMLElement(this, feedUrl);
    XMLElement maxC = xml.getChild("temperature/max/celsius");
    String maxCNumb = maxC.getContent();
    gotCelsiusNumb =  parseInt(maxCNumb);
    println("予想最高気温"+maxCNumb+"℃");

    return gotCelsiusNumb;
  }
  catch(NullPointerException e){
    println("最高気温情報無し");
    gotCelsiusNumb = errorCelsius;
    return gotCelsiusNumb;
  }

}

//インターネットから予想最低気温を取得する
int getForecastMinCelsius(String feedUrl){
  int gotCelsiusNumb = -274;

  try{
    XMLElement xml = new XMLElement(this, feedUrl);
    XMLElement minC = xml.getChild("temperature/min/celsius");
    String minCNumb = minC.getContent();
    gotCelsiusNumb =  parseInt(minCNumb);
    println("予想最低気温"+minCNumb+"℃");

    return gotCelsiusNumb;	
  }
  catch(NullPointerException e){
    println("最低気温情報無し");
    gotCelsiusNumb = errorCelsius;
    return gotCelsiusNumb;
  }
}

//twitterに投稿する関数
void twit(String str){
  println("Date : "+hour()+":"+minute());

  try{
    Status status1 =twitter.updateStatus(str);
    println(str);
  } 
  catch(TwitterException e) {
    //twitterAPIのエラーコードについては以下を参照
    //http://apiwiki.twitter.com/HTTP-Response-Codes-and-Errors
    println(e.getStatusCode());
  }
}

